function Cus00400_Rateio_nao_estocaveis(ScreenService, General, templateManager, CUSUtilities) {
    
    this.initializeFilter = function(widget){
        var row = {
			CDFILIAL: getLocalVar('CDFILIAL'),
			NMFILIAL: getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL')
        }; 
        var prodfilter = widget.getField('NMPRODUTOINI').dataSourceFilter.find(e=>e.name == 'CDFILIAL');
        prodfilter.value = getLocalVar('CDFILIAL');
        CUSUtilities.startFilter(widget, row);
    };
    
    this.initializeFilterRelatorio = function(widget){
       	widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
		widget.currentRow.NMFILIAL = getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL');
    };
    
    this.onEnter = function(widget){
        widget.dataSourceFilter = [
            {
				"name": "P_CDFILIAL",
				"operator": "=",
				"value": widget.appliedFilter.FILTER_ROW.CDFILIAL
			}
        ];
        widget.reload();
        this.filterApply(widget);
    };
    
    this.prodCompleto = function(field){
        var prodini = field.widget.getField('NMPRODUTOINI');
        var prodfin = field.widget.getField('NMPRODUTOFIN');
        var inifilter = prodini.dataSourceFilter.find(e=>e.name == 'CDFILIAL');
        inifilter.value = field.widget.currentRow.CDFILIAL;
        if(prodfin){
            var finfilter = prodfin.dataSourceFilter.find(e=>e.name == 'CDFILIAL');
            finfilter.value = field.widget.currentRow.CDFILIAL;
        }
        this.alteraProdutoFinal(field);
        prodini.reload();
        prodfin.reload();
    };
    
    this.filterApply = function(widget){
        var stripe = templateManager.container.getWidget('widgetStripe');
        stripe.currentRow.FILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL + ' - ' + widget.appliedFilter.FILTER_ROW.NMFILIAL;
    };
    
    this.filterService = function(widget){
        var rateio = templateManager.container.getWidget('WIDGET_RATEIO');  
        
        widget.dataSourceFilter = [
            {
                "name": "P_CDFILIAL",
				"operator": "=",
				"value": rateio.appliedFilter.FILTER_ROW.CDFILIAL
			},
			{
				"name": "P_CDPRODUTO",
				"operator": "=",
				"value": rateio.currentRow.CDPRODUTO
			}
        ];
        
        widget.reload();
    };
    
    this.openTabServRateio =function(widget){
        if(widget.isValid()){
            var rateio = templateManager.container.getWidget('WIDGET_RATEIO');
            General.changeWidgetAcessibility(rateio.widgets, true);
            widget.openTab('WIDGET_SERVICO_RATEIO');
        }  
    };
    
    function validRateio(){
        var widget = templateManager.container.getWidget('WIDGET_SERVICO_RATEIO');
        var rateio = templateManager.container.getWidget('WIDGET_RATEIO').currentRow.RATEIO;
        var porcent = 0;
        if(rateio != "") porcent = parseFloat(rateio.replace(',', '.'));
        var changed = widget.dataSource.data.filter(e => e.changed ==true);
        
        changed.forEach(function(data){
            if(data.changed_PERATENESTO == null) data.changed_PERATENESTO = '0,00';  
            porcent = porcent - parseFloat(data.changed_PERATENESTO.replace(',', '.'));
            porcent = porcent + parseFloat(data.PERATENESTO.replace(',', '.'));
        });
        
        if(porcent > 100 || porcent <= 0) return false;
        else return true;
    }
    
    this.saveInline = function(widget){
        if(validRateio()){
            var rateio = templateManager.container.getWidget('WIDGET_RATEIO');
            var changed = widget.dataSource.data.filter(e => e.changed ==true);
            changed.forEach(function(data){
               data.CDPRODUTO = rateio.currentRow.CDPRODUTO;
               data.PERATENESTO = data.PERATENESTO.replace(',', '.');
            });
            General.callRestEngine("cus_operacional#/save", "DataSet", changed).then(function(response){
                if(response.dataset.save[0]){
                    widget.commitInlineEdit();
                    ScreenService.closeSwipe().then(function(){
                        ScreenService.successNotification('Salvo com sucesso!');
                        rateio.reload();
                    });
                }    
            });
        }else{
            ScreenService.showMessage('A porcentagem de rateio não deve ser menor que 0 ou maior que 100.');
        }  
    };
    
    this.back = function(args){
      General.backOrCancel(args);
      templateManager.container.getWidget('WIDGET_RATEIO').reload();
    };
    
    this.ReportPopup = function(widget){
        if(widget.isValid()){
            if(widget.currentRow.CDPRODUTOINI && widget.currentRow.CDPRODUTOFIN && !General.comparaPratoProduto(widget.currentRow.CDPRODUTOINI, widget.currentRow.CDPRODUTOFIN, getLocalVar('CDPICTPROD'))) {
                ScreenService.showMessage('O produto inicial deve ser menor ou igual ao produto final.', 'error');
            } else {
				General.openReportPopup(widget, relatorio, [widget], CUSUtilities.getReportFormats());
			}
        }
    };
    
    function relatorio(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        widget.currentRow.CDPICTPROD = getLocalVar("CDPICTPROD").replace(/[^(/\.|\ )]/g, "@");
        General.openReport('cus_operacional#/cus00400', widget.currentRow.CD_REPORT_NAME, widget.currentRow);
    }
    
    this.delete = function(widget){
        ScreenService.confirmMessage('Deseja excluir o registro?').then(function(){
            var checkedRows = widget.getCheckedRows();
            checkedRows.forEach(function(data){ data.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL; });
            
            General.callRestEngine("cus_operacional#/delete", "DataSet", checkedRows).then(function(response){
                if(response.dataset.delete[0]){
                    ScreenService.successNotification('Excluido com sucesso!');
                    widget.reload();
                    widget.unSelectAll();
                }
            });
        });
    };
    
    this.alteraProdutoFinal = function(field){
        let widget = field.widget;
        if(field.name === 'NMPRODUTOINI'){
            widget.currentRow.NMPRODUTOFIN = angular.copy(widget.currentRow.NMPRODUTOINI);
            widget.currentRow.CDARVPRODINI = angular.copy(widget.currentRow.CDARVPROD);
            widget.currentRow.CDARVPRODFIN = angular.copy(widget.currentRow.CDARVPRODINI);
            widget.currentRow.CDPRODUTOINI = angular.copy(widget.currentRow.CDARVPRODINI);
            widget.currentRow.CDPRODUTOFIN = angular.copy(widget.currentRow.CDPRODUTOINI);
        } else {
            widget.currentRow.CDARVPRODFIN = angular.copy(widget.currentRow.CDARVPROD);
            widget.currentRow.CDPRODUTOFIN = angular.copy(widget.currentRow.CDARVPROD);
        }
        if(field.name === 'NMFILIAL'){
            widget.currentRow.NMPRODUTOINI = "";
            widget.currentRow.NMPRODUTOFIN = "";
            widget.currentRow.CDPRODUTOINI = "";
            widget.currentRow.CDPRODUTOFIN = "";
        }
    };
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Cus00400_Rateio_nao_estocaveis', Cus00400_Rateio_nao_estocaveis);
});